import SDL;
import std.string;
import kinds;
import util;
import std.stdio;
import base;
import images = images.src.images;
import opengl;
import glutils;
import std.typetuple;
import system;
import enemy;
import ship;

void stop_scroll(Registry reg)
{
  Scroll scr = reg.search!(Scroll)(SubKind.SCROLL);
  scr.v = Vector(0, 0);
}

void set_scroll(Registry reg, int y)
{
  Scroll scr = reg.search!(Scroll)(SubKind.SCROLL);
  scr.v = Vector(0, y);
}
class Events1{
const static Event[] events = [
  {1, &fun0},
  {1, &fun6},
  {1, &fun12},
  {1, &fun2},
  {60, &fun15},
  {140, &fun16},
  {180, &fun3},
  {200, &fun1},
  {380, &fun4},
  {440, &fun7},
  {440, &fun13},
  {500, &fun5},
  {700, &fun10},
  {720, &fun8},
  {1000, &fun14},
  {1000, &fun9},
  {1280, &fun11},
];
static void fun0(Registry reg){
  reg.root.set_restart_point(1);
}
static void fun6(Registry reg){
  reg.add(new NormalWall(Rect(0, 0, 40, 200)));
}
static void fun12(Registry reg){
  set_scroll(reg, 1);
}
static void fun2(Registry reg){
  reg.add(new NormalWall(Rect(0, -200, 40, 200)));
}
static void fun15(Registry reg){
  reg.add(new OptionCapsule(Point(120, -20)));
}
static void fun16(Registry reg){
  reg.add(new ReflectiveCapsule(Point(260, -20)));
}
static void fun3(Registry reg){
  reg.add(new NormalWall(Rect(0, -220, 40, 200)));
}
static void fun1(Registry reg){
  reg.add(new NormalWall(Rect(180, -100, 200, 80)));
}
static void fun4(Registry reg){
  reg.add(new NormalWall(Rect(0, -220, 40, 200)));
}
static void fun7(Registry reg){
  reg.add(new NormalWall(Rect(460, -300, 100, 280)));
}
static void fun13(Registry reg){
  reg.add(new Flak(Point(60, -20), 90));
}
static void fun5(Registry reg){
  reg.add(new NormalWall(Rect(40, -60, 200, 40)));
}
static void fun10(Registry reg){
  reg.add(new NormalWall(Rect(160, -60, 300, 40)));
}
static void fun8(Registry reg){
  reg.add(new NormalWall(Rect(460, -300, 100, 280)));
}
static void fun14(Registry reg){
  reg.add(new NormalWall(Rect(240, -240, 40, 220)));
}
static void fun9(Registry reg){
  reg.add(new NormalWall(Rect(460, -300, 100, 280)));
}
static void fun11(Registry reg){
  stop_scroll(reg);
}
}
const Event[][] events = [
  Events1.events,
];
