import images = images.src.images;
import opengl;

void function()[char] chars;

static this() {
  chars['-'] = &images.alphabet.minus.draw;
  chars['.'] = &images.alphabet.dot.draw;
  chars['/'] = &images.alphabet.slash.draw;
  chars['!'] = &images.alphabet.exclamation.draw;
  chars['?'] = &images.alphabet.question.draw;
  
  chars['0'] = &images.alphabet.zero.draw;
  chars['1'] = &images.alphabet.one.draw;
  chars['2'] = &images.alphabet.two.draw;
  chars['3'] = &images.alphabet.three.draw;
  chars['4'] = &images.alphabet.four.draw;
  chars['5'] = &images.alphabet.five.draw;
  chars['6'] = &images.alphabet.six.draw;
  chars['7'] = &images.alphabet.seven.draw;
  chars['8'] = &images.alphabet.eight.draw;
  chars['9'] = &images.alphabet.nine.draw;
  chars[':'] = &images.alphabet.colon.draw;
  
  chars['A'] = &images.alphabet.cap_a.draw;
  chars['B'] = &images.alphabet.cap_b.draw;
  chars['C'] = &images.alphabet.cap_c.draw;
  chars['D'] = &images.alphabet.cap_d.draw;
  chars['E'] = &images.alphabet.cap_e.draw;
  chars['F'] = &images.alphabet.cap_f.draw;
  chars['G'] = &images.alphabet.cap_g.draw;
  chars['H'] = &images.alphabet.cap_h.draw;
  chars['I'] = &images.alphabet.cap_i.draw;
  chars['J'] = &images.alphabet.cap_j.draw;
  chars['K'] = &images.alphabet.cap_k.draw;
  chars['L'] = &images.alphabet.cap_l.draw;
  chars['M'] = &images.alphabet.cap_m.draw;
  chars['N'] = &images.alphabet.cap_n.draw;
  chars['O'] = &images.alphabet.cap_o.draw;
  chars['P'] = &images.alphabet.cap_p.draw;
  chars['Q'] = &images.alphabet.cap_q.draw;
  chars['R'] = &images.alphabet.cap_r.draw;
  chars['S'] = &images.alphabet.cap_s.draw;
  chars['T'] = &images.alphabet.cap_t.draw;
  chars['U'] = &images.alphabet.cap_u.draw;
  chars['V'] = &images.alphabet.cap_v.draw;
  chars['W'] = &images.alphabet.cap_w.draw;
  chars['X'] = &images.alphabet.cap_x.draw;
  chars['Y'] = &images.alphabet.cap_y.draw;
  chars['Z'] = &images.alphabet.cap_z.draw;
}

void draw_text(char[] text)
{
  glPushMatrix();
  foreach(char ch; text) {
    if (ch in chars) {
      chars[ch]();
    }
    glTranslated(10, 0, 0);
  }
  glPopMatrix();
}

void glColor3da(double[] color)
{
  glColor3dv(cast(double*) color);
}

void translated_scaled(double x, double y, double scale,
                       void delegate() fun)
{
  glPushMatrix();
  glTranslated(x, y, 0);
  glScaled(scale, scale, 1);
  fun();
  glPopMatrix();
}
