module kinds;

private const int RATE = 3000;
enum Kind {
  FIRST,
  PRE,
  PLAYER,
  ETC_FAST,
  BULLET,
  ENEMY,
  OPTION,
  CHARGE_BLOCKER,
  WALL,
  SHOT,
  CAPSULE,
  ETC,
  POST,
  LAST
}

enum SubKind {
  FIRST = 0,
  PRE_FIRST = Kind.PRE*RATE,
  INPUT,
  RECORDER,

  RECORDPLAYIF,
  SYSTEMINFO,
  GAMEINFO,
  DRAW_WINDOW,

  PLAYER_FIRST = Kind.PLAYER*RATE,
  PLAYER,

  ETC_FAST_FIRST = Kind.ETC_FAST*RATE,
  DEF_BULLET_LEADER,
  BOSS3CHEKER,
  
  BULLET_FIRST = Kind.BULLET*RATE,
  NORMAL_BULLET,
  DEF_BULLET_CHILD,
  HIDDEN_BULLET,
  
  ENEMY_FIRST = Kind.ENEMY*RATE,
  NORMAL_ENEMY,
  BOSS_ENEMY,
  BOSS3_A,
  
  OPTION_FIRST = Kind.OPTION*RATE,
  FIXED_OPTION,
  FB_OPTION,
  SIDE_OPTION,

  CHARGE_BLOCKER_FIRST = Kind.CHARGE_BLOCKER*RATE,
  CHARGE_BLOCKER,
  
  WALL_FIRST = Kind.WALL*RATE,
  WALL,
  
  SHOT_FIRST = Kind.SHOT*RATE,
  NORMAL_SHOT,
  OPTIONS_SHOT,
  FIVEWAY_SHOT,
  SHORTRANGE,
  SHORTRANGE_EXPLOSION,
  REFLECTIVE_SHOT,
  BLADE_SHOT,
  CHARGE_EFFECT,
  CHARGE_SHOT,
  
  CAPSULE_FIRST = Kind.CAPSULE*RATE,
  OPTION_CAPSULE,
  FIXED_OPTION_CAPSULE,
  FB_OPTION_CAPSULE,
  SIDE_OPTION_CAPSULE,
  SHORTRANGE_CAPSULE,
  REFLECTIVE_CAPSULE,
  FIVEWAY_CAPSULE,
  BLADE_CAPSULE,
  
  ETC_FIRST = Kind.ETC*RATE,
  BG_LINE,
  TESTER,
  TEXTTESTER,
  TEST_MARKER,
  DESTROYED_PLAYER,
  DESTROYED_ENEMY,
  BOSS5_RINGCREATOR,
  DEF_BULLET_CREATOR,
  HIDDEN_ENEMY,
  NORMAL_ENEMY_CREATOR,
  NORMAL_BULLET_CREATOR,
  WALL_CREATOR,
  NORMAL_EFFECT,
  BOSS7_EXPLOSION,
  BOSS3_B,
  EXTEND,
  
  POST_FIRST = Kind.POST*RATE,
  SCROLL,
  STAGE,
  SHIFT_SCREEN,
  
  STAGEEND,
  GAMEEND,
  TITLE,
  GAMEOVER,
  CONTINUE,
  
  BULLET_WALL_COLLISION_DETECTOR,
  BULLET_CHARGE_COLLISION_DETECTOR,
  SHOT_ENEMY_COLLISION_DETECTOR,
  WALL_ENEMY_COLLISION_DETECTOR,
  SHOT_WALL_COLLISION_DETECTOR,
  PLAYER_WALL_COLLISION_DETECTOR,
  PLAYER_ENEMY_COLLISION_DETECTOR,
  PLAYER_BULLET_COLLISION_DETECTOR,
  PLAYER_CAPSULE_COLLISION_DETECTOR,

  PLAYER_RESETER,
  RESET,
  
  LAST,
}

Kind subkind2kind(SubKind sk)
{
  return cast(Kind)(sk/RATE);
}
